/**
 * Created by robin on 01/31/16.
 */

(function () {
    'use strict';
    angular.module('luticateAuth')
        .factory('luticateAuthSettings', ['luticateAuthSettingsDataAccess', 'luticateAuthCache', '$q',
            function(luticateAuthSettingsDataAccess, luticateAuthCache, $q) {

                var luticateAuthSettings = {
                    getAll: luticateAuthSettingsDataAccess.getAll,
                    get: luticateAuthSettingsDataAccess.get,
                    edit: luticateAuthSettingsDataAccess.edit,
                    add: luticateAuthSettingsDataAccess.add,
                    del: luticateAuthSettingsDataAccess.del,
                    getEffectiveUser: luticateAuthSettingsDataAccess.getEffectiveUser,
                    getAllEffectiveUser: luticateAuthSettingsDataAccess.getAllEffectiveUser,
                    getEffectiveMe: luticateAuthSettingsDataAccess.getEffectiveMe,
                    getAllEffectiveMe: luticateAuthSettingsDataAccess.getAllEffectiveMe
                };

                luticateAuthSettings.loadSettings = function(promise)
                {
                    var defer = $q.defer();
                    luticateAuthSettings.getAllEffectiveMe(promise)
                        .then(function(settings)
                        {
                            var sets = {};
                            for (var i = 0; i < settings.Data.length; ++i) {
                                var s = settings.Data[i];
                                sets[s.Name] = s;
                            }
                            luticateAuthCache.setEffectiveSettings(sets);
                            defer.resolve(settings.Data);
                        }, defer.reject);
                    return defer.promise;
                };

                return luticateAuthSettings;
        }]);
})();