/**
 * Created by robin on 01/31/16.
 */

(function () {
    'use strict';
    angular.module('luticateAuth')
        .factory('luticateAuthSettingsUser', ['luticateAuthSettingsUserDataAccess', '$q', 'luticateAuthCache',
            function(luticateAuthSettingsUserDataAccess, $q, luticateAuthCache) {

                var luticateAuthSettingsUser = {
                    getAll: luticateAuthSettingsUserDataAccess.getAll,
                    get: luticateAuthSettingsUserDataAccess.get,
                    edit: luticateAuthSettingsUserDataAccess.edit,
                    editMe: luticateAuthSettingsUserDataAccess.editMe
                };

                luticateAuthSettingsUser.editMe = function(data, promise)
                {
                    var defer = $q.defer();
                    luticateAuthSettingsUserDataAccess.editMe(data, promise)
                        .then(function(result)
                        {
                            luticateAuthCache.setEffectiveSettingValue(data.setting_name, data.setting_value);
                            defer.resolve(result);
                        }, defer.reject);
                    return defer.promise;
                };

                return luticateAuthSettingsUser;
        }]);
})();